#include "../../include/pthreadwrapper/threadedexecutor.h"

#ifdef XMEM
	#include <xmem.h>
#endif

namespace PThread
{

ThreadedExecutor::~ThreadedExecutor()
{
	for(std::vector<Thread *>::iterator i=m_threads.begin(); i!=m_threads.end(); i++)
	{
		(*i)->Cancel();
		(*i)->Join();
		delete (*i);
	}
}

void ThreadedExecutor::Cancel()
{
	for(std::vector<Thread *>::iterator i=m_threads.begin(); i!=m_threads.end(); i++)
	{
		(*i)->Cancel();	
	}
}

void ThreadedExecutor::CleanupFinished()
{
	for(std::vector<Thread *>::iterator i=m_threads.begin(); i!=m_threads.end(); )
	{
		if((*i)->IsRunning()==false)
		{
			delete (*i);
			i=m_threads.erase(i);
		}
		else
		{
			i++;
		}
	}
}

void ThreadedExecutor::Execute(Runnable *runnable)
{
	CleanupFinished();
	m_threads.push_back(new Thread(runnable));	
}

void ThreadedExecutor::Join()
{
	for(std::vector<Thread *>::iterator	i=m_threads.begin(); i!=m_threads.end(); i++)
	{
		(*i)->Join();
	}
	CleanupFinished();
}

}	// namespace
